unit Question1_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, pngimage, Math;

type
  TfrmQuestion1 = class(TForm)
    pnlHeading: TPanel;
    gpbQuestion11: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtName: TEdit;
    edtIDNumber: TEdit;
    Label3: TLabel;
    btnQuest11: TButton;
    gpbQuestion12: TGroupBox;
    Label4: TLabel;
    lblDiscount: TLabel;
    lblDonation: TLabel;
    imgDiscount: TImage;
    imgDonation: TImage;
    gpbQuestion13: TGroupBox;
    Label7: TLabel;
    edtAmount: TEdit;
    edtDisplay: TEdit;
    btnQuest13: TButton;
    gpbQuestion14: TGroupBox;
    ckbBusiness: TCheckBox;
    Label9: TLabel;
    edtPart1: TEdit;
    Label10: TLabel;
    edtPart2: TEdit;
    Label11: TLabel;
    edtPart3: TEdit;
    btnQuest14: TButton;
    lblWelcomeMessage: TLabel;
    Label5: TLabel;
    procedure btnQuest11Click(Sender: TObject);
    procedure imgDiscountClick(Sender: TObject);
    procedure imgDonationClick(Sender: TObject);
    procedure btnQuest13Click(Sender: TObject);
    procedure btnQuest14Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  sName, sIdNumber: string;
  frmQuestion1: TfrmQuestion1;
  typeCard  : string; // provided
  charString: string = '!@#$%]&*^~'; // provided

implementation

{$R *.dfm}

procedure TfrmQuestion1.btnQuest11Click(Sender: TObject);
var
  bNoSpace, bNoID, bIDLen: boolean;
begin
  // Question 1.1
  sName := edtName.Text;
  bNoSpace := pos(' ', sName) = 0;
  if bNoSpace then
    showMessage('The name surname field does not contain a space.');
  sIdNumber := edtIDNumber.Text;
  bNoID := length(sIdNumber) = 0;
  bIDLen := length(sIdNumber) <> 13;
  if bNoID then
    showMessage('An ID number must be entered.')
  else if bIDLen then
    showMessage('The ID number does not consist of 13 digits.');

  if (bNoSpace = false) AND (bNoID = false) AND (bIDLen = false) then
    lblWelcomeMessage.visible := true;
end;

procedure TfrmQuestion1.imgDonationClick(Sender: TObject);
begin
  // Question 1.2
  lblDonation.Font.Style := [fsBold];
  lblDiscount.Font.Style := [];
  typeCard := 'CH';
end;

procedure TfrmQuestion1.imgDiscountClick(Sender: TObject);
begin
  // Question 1.2
  lblDiscount.Font.Style := [fsBold];
  lblDonation.Font.Style := [];
  typeCard := 'DI'
end;

procedure TfrmQuestion1.btnQuest13Click(Sender: TObject);
var
  rDiscount, rDonation: real;
begin
  // Question 1.3
  if typeCard = 'DI' then
  begin
    rDiscount := 1.5 / 100 * StrToFloat(edtAmount.Text);
    edtDisplay.Text := '1.5% discount on your purchase amount is ' + FloatToStrF
      (rDiscount, ffCurrency, 6, 2) + '.';
  end
  else
  begin
    rDonation := Math.Ceil(StrToFloat(edtAmount.Text) / 100) * 3;
    edtDisplay.Text := 'An amount of ' + FloatToStrF(rDonation, ffCurrency, 6,
      2) + ' will be donated to charity.';
  end
end;

procedure TfrmQuestion1.btnQuest14Click(Sender: TObject);
var
  sSymbol: string;
  iPosition: integer;
  bCard: char;
begin
  // Question 1.4
  if ckbBusiness.Checked then
    bCard := 'B'
  else
    bCard := 'P';
  iPosition := StrToInt(sIdNumber[length(sIdNumber)]);
  sSymbol := charString[iPosition + 1];
  edtPart1.Text := bCard + copy(sIdNumber, 1, 3);
  edtPart2.Text := IntToStr(iPosition) + sSymbol;
  edtPart3.Text := typeCard;
end;

procedure TfrmQuestion1.FormActivate(Sender: TObject);
begin
  CurrencyString := 'R';
end;

end.
