unit CardHolder_U;

interface
  uses SysUtils,Math;
type
  TCardHolder = class(TObject)
  private
    fCardNumber: string;
    fCellNumber: string;
    fNumVisits: integer;
    fLoyaltyPoints: integer;
    fHealthLevel: char;
  public
  constructor create(sCardNumber,sCellNumber: string; iLoyaltyPoints: integer);
  procedure setNumVisits(iNumVisits: integer);
  Procedure increaseLoyaltyPoints(rTotal: real);
  procedure updateHealthLevel(rHealth,rTotal: real);
  function isCorrect(sAccessCode:string): boolean;
  function identifyStarShopper: string;
  function toString: string;
  end;

implementation

{ TCardHolder }
// Question 2.1.1
constructor TCardHolder.create(sCardNumber, sCellNumber: string; iLoyaltyPoints: integer);
begin
    fCardNumber := sCardNumber;
    fCellNumber := sCellnumber;
    fLoyaltyPoints := iLoyaltyPoints;
    fNumVisits := 0;
    fHealthLevel := 'S';
end;
// Question 2.1.2
procedure TCardHolder.setNumVisits(iNumVisits: integer);
begin
  fNumVisits := iNumVisits;
end;
// Question 2.1.3
procedure TCardHolder.increaseLoyaltyPoints(rTotal: real);
var
  iLoyaltyPoints: integer;
begin
  fLoyaltyPoints := fLoyaltyPoints + trunc(rTotal) div 4;
end;
// Question 2.1.4
procedure TCardHolder.updateHealthLevel(rHealth, rTotal: real);
var
  rPercent: real;
begin
  rPercent := rHealth/rTotal * 100;
  if rPercent < 10  then
    fHealthLevel:='S'
  else
    if rPercent >= 40 then
       fHealthLevel := 'P'
    else
       fHealthLevel := 'G'
end;
// Question 2.1.5
function TCardHolder.isCorrect(sAccessCode: string): boolean;
var
  a: integer;
  b,iSum: integer;
  sCellNumber : string;
begin
  iSum:=0;
  sCellNumber := fCellNumber;
  for a := length(sCellNumber) downto 1 do
    if sCellNumber[a] = '0' then
      delete(sCellNumber,a,1);
  if length(sCellNumber) mod 2 = 0  then
    for b := 1 to (length(sCellNumber) div 2) do
      iSum := iSum + StrToInt(copy(sCellNumber,2*b-1,2));
  if length(sCellNumber) mod 2 <> 0  then
   begin
     iSum:=StrToInt(sCellNumber[1]);
     for b := 1 to (length(sCellNumber) div 2) do
      iSum := iSum + StrToInt(copy(sCellNumber,2*b,2));
   end;
  if StrToInt(sAccessCode) = iSum then
    result:=true
  else
    result := false;
end;
// Question 2.1.6
function TCardHolder.identifyStarShopper: string;
begin
  result := '';
  if ((fLoyaltyPoints > 2000) AND ( fnumVisits > 10)) OR ( fHealthLevel = 'P') then
     result := 'STAR shopper'
end;

// Provided code
function TCardHolder.toString: string;
begin
  result:= fCardNumber + #13 + 'Contact number: '+ fCellNumber + #13+#13+ 'Updated number of loyalty points: '+IntToStr(fLoyaltyPoints)+#13+'Number of visits: '+IntToStr(fNumVisits)+#13+'Health evaluation status: '+fHealthLevel;
end;

end.
