unit Question2_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, CardHolder_U;

type
  TfrmQuestion2 = class(TForm)
    Panel1: TPanel;
    gbpQuestion2_1: TGroupBox;
    gpbQuestion2_2: TGroupBox;
    Label1: TLabel;
    lblCardNumber: TLabel;
    cmbCardNumbers: TComboBox;
    Panel2: TPanel;
    Label2: TLabel;
    lblLoyaltyPoints: TLabel;
    lblCellNumber: TLabel;
    Panel3: TPanel;
    Label3: TLabel;
    edtCode: TEdit;
    btnQuest221: TButton;
    redOutput: TRichEdit;
    btnQuest222: TButton;
    procedure cmbCardNumbersChange(Sender: TObject);
    procedure btnQuest221Click(Sender: TObject);
    procedure btnQuest222Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQuestion2: TfrmQuestion2;
  objCardholder: TCardHolder; // provided
  myFile: Textfile;

implementation

{$R *.dfm}

procedure TfrmQuestion2.btnQuest221Click(Sender: TObject);
var
  sCardHolder: string;
  sCellNumber: string;
  sLoyaltyPoints: string;
  sAccess: string;
  sLineOne, sLineTwo, sLineThree: string;
  rTotalSpent, rTotalHealth: real;
  iVisits: integer;
begin
  sCardHolder := cmbCardNumbers.items[cmbCardNumbers.ItemIndex];
  sCellNumber := lblCellNumber.Caption;
  sLoyaltyPoints := lblLoyaltyPoints.Caption;

  objCardholder := TCardHolder.create(sCardHolder, sCellNumber,
    StrToInt(sLoyaltyPoints));
  sAccess := edtCode.Text;
  if objCardholder.isCorrect(sAccess) then
  begin
    showMessage('The access code is correct.');
    rTotalSpent := 0;
    rTotalHealth := 0;
    iVisits := 0;
    assignFile(myFile, 'DataJanuary2017.txt');
    reset(myFile);
    while not eof(myFile) do
    begin
      readln(myFile, sLineOne);
      readln(myFile, sLineTwo);
      readln(myFile, sLineThree);
      if sLineOne = sCardHolder then
      begin
        rTotalSpent := rTotalSpent + StrToFloat(sLineTwo);
        rTotalHealth := rTotalHealth + StrToFloat(sLineThree);
        inc(iVisits);
      end; // end if
    end; // end while
    closeFile(myFile);

    objCardholder.increaseLoyaltyPoints(rTotalSpent);
    objCardholder.setNumVisits(iVisits);
    objCardholder.updateHealthLevel(rTotalHealth, rTotalSpent);
    btnQuest222.Enabled := true;
  end // end isCorrect
  else
  begin
    showMessage('Incorrect access code.');
    edtCode.Clear;
  end;
end;

procedure TfrmQuestion2.btnQuest222Click(Sender: TObject);
begin
  redOutput.Clear;
  redOutput.Lines.Add(objCardholder.toString);
  redOutput.Lines.Add(objCardholder.identifyStarShopper);
end;

// Code provided
procedure TfrmQuestion2.cmbCardNumbersChange(Sender: TObject);
begin
  edtCode.Clear;
  redOutput.Clear;
  btnQuest222.Enabled := false;
  case cmbCardNumbers.ItemIndex of
    0:
      begin
        lblLoyaltyPoints.Caption := '2130';
        lblCellNumber.Caption := '0812345678';
      end;

    1:
      begin
        lblLoyaltyPoints.Caption := '5723';
        lblCellNumber.Caption := '0822001100';
      end;

    2:
      begin
        lblLoyaltyPoints.Caption := '12908';
        lblCellNumber.Caption := '0740998877';
      end;

    3:
      begin
        lblLoyaltyPoints.Caption := '500';
        lblCellNumber.Caption := '0720951083';
      end;
  end;

end;

end.
